/*!
 * @file		ChatListCtrl.h
 * @brief		޽ â  ȭ  Ʈ Ʈ
 * @author		Jinwoo.Lee(jinwoo.lee@nhn.com)
 * @date		2012-07-11 
 * @warning
 * @attention	Copyright 2012 NTS Corp. All rights reserved.
 */
#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "ChatRoomList.hpp"
#include "LayeredDlg.h"

#define COLOR_NORMAL_TEXT		(RGB(34, 34, 34))		// #222222
#define COLOR_NORMAL_BK			(RGB(255, 255, 255))
#define COLOR_SELECTED_TEXT		(RGB(34, 34, 34))		// #222222
#define COLOR_SELECTED_BK		(RGB(220, 236, 245))	// #dcecf5
#define COLOR_LINK_NORMAL_TEXT	(RGB(0, 0, 255))
#define COLOR_LINK_HOVER_TEXT	(RGB(255, 0, 0))
#define COLOR_CHAT_LIST_BORDER	(RGB(226,227,229))		// #dcdcdc

#define COLUMN_INDEX_ICON			0
#define COLUMN_INDEX_NAME			1
#define COLUMN_INDEX_LAST_MSG_TIME	2
#define COLUMN_INDEX_CHAT			3
#define COLUMN_MAX					4	// ÷ ߰Ǹ IDEX ߰  MAX  ÷ش.


class CChatDlg;
class MainFrame;


class CDuiOrgList
{
public:
	CDuiOrgList(MainFrame* pFrame){m_pFrame = pFrame;}
	~CDuiOrgList();

	std::vector<Node*> GetSelectedItems();


private:
	MainFrame* m_pFrame;	
};

class CRecentChatListManager
{
public:
	CRecentChatListManager(MainFrame* pFrame);
	~CRecentChatListManager();

	CChatDlg *RevertChatDialog(int nRoomID);
	void InitChatRoomList(CChatRoomList* pChattingRoomList);
	void OnRButtonEvent( bool bDown, int nIndex );
	void MenuCmd( int nCmdID);
	void OpenChatDialog(const list<Node*> &SelectRooms);
	void CloseChatDialogs(const CUIntArray& nRoomIDArray);
	void LeaveChatDialog(const list<Node*> &SelectRooms);
	void RemoveChatRoomForTimeout();
	void SendFileInChatDialog(const list<Node*> &SelectRooms);
	void SendSMS(const list<Node*> &SelectRooms);
	void SendMiniMail(const list<Node*> &SelectRooms);
	list<Node*> GetSelectedItems();
	int GetCount();
	void RemoveChatRoom(int nRoomID, BOOL bDeleteData = TRUE);
	void AddChatRoomList(CChatDlg* pChatDlg);
	void AddChatRoomList(const NE_MYROOM_DATA& myRoomData);
	void AddChatRoomList(ChatRoomItem* pItem);
	void UpdateChatRoomList(CChatDlg* pChatDlg, BOOL bSort=FALSE );
	void UpdateChatRoomList(ChatRoomItem *pChatRoomItem);
	BOOL FindSingleChatDlg(LPCTSTR strUserID, int nRoomID);
	BOOL DisplaySearchChatRoomList(CString strSearchText);
	void AddAllChatRoomList();
	void ClearChatRoomList();
	int FindChatRoomIndex(int nRoomNo);
	CString ParseChatTime(CTime tmChat);
	void SetItemChatDlg(int nRoomID, CChatDlg *pChatDlg);
	ChatRoomItem *GetChatRoomItem(int nRoomID);
	void ResortChatRoomList(vector <ChatRoomItem*> &vecChatItem);
	void UpdateRecentUserStatus(IGTMessengerActor *pActor, LPCWSTR strUserID);
	void UpdateAllChatRoomTime();
	static int __cdecl ItemComareFunc(void *pvlocale,const void *elem1, const void *elem2);

private:
	CChatRoomList*		m_pChattingRoomList;
	MainFrame			*m_pFrame;
	list<ChatRoomItem*> m_listChatItem;
	CCriticalSection	m_csChatDialogList;
};
